#!/usr/bin/perl

# Variablendeklaration
my($mytime) = time();
my($t1) = time();
my($t2);
my($version) = "1.1j";
my($root) = $ENV{'DOCUMENT_ROOT'};

# Einlesen der Formulardaten
&parseForm;

# Unterverzeichnisse mit durchsuchen?
$subDir = 1;

# Verzeichnis mit zeigen?
$listDirs = 0;

# Logbuch fhren gemaess Formularuebergabe?
if ($FORM{'log'} ne "")
{
	&writeLog;
}

# Ueberpruefen Server-Basisverzeichnis-Uebergabe aus Formular
if ($FORM{'base'} eq "")
{
	myError("Server-Basisverzeichnis nicht bergeben" );
}

# Ueberpruefen URL-Uebergabe aus Formular
if ($FORM{'rbase'} eq "")
{
	myError("URL nicht bergeben" );
}

# Sortiermethode per Formular (0 = unsortiert, 1 = zeitlich geordnet, 2 = umgekehrt zeitlich geordnet)
if ($FORM{'sortmode'} eq "")
{
	$FORM{'sortmode'} = '1';
}

# Anzahl Tage per Formular
if ($FORM{'ndays'} eq "")
{
	$FORM{'ndays'} = '7';
}

# Verzeichnisangabe im Formular
if ($FORM{'dirs'} ne "")
{
	@directories = split( /;/,$FORM{'dirs'});
	$listDirs = 1;
	$FORM{'dosub'} = "no";
}

# Keine Unterverzeichnisse gemaess Formular
if (lc($FORM{'dosub'}) eq "no")
{
	$subDir = 0;
}

# Welche Verzeichnisse sollen nicht durchsucht werden?
# Koennte auch per Formular uebergeben werden, provoziert allerdings
# "Handeingaben", um es halt mal zu versuchen ...
# $excdirs = 0;
# if ($FORM{'excdirs'} ne "")
# {
#	@excpaths = split(/;/,$FORM{'excdirs'});
#	$excdirs = 1;
# }
# @disallow = (	"$root/_private", "$root/komm/karten/cards", "$root/_fpclass", "$root/stats");

@excdirs = ("_private", "hauskauf", "komm/karten/cards", "_fpclass", "statistik", "mb-team", "filmtier", "forum", "baro", "lrh", "tryout", "vti_bin", "vti_conf", "vti_log", "vti_pvt", "vti_txt");
$exclusion = 1;

# Zeitberechnung
$mytime = $mytime - ($FORM{'ndays'} * 86400 );

# HTML-Header
&htmlTop;

# Verzeichnisausgabe?
if ($listDirs > 0)
{ 
	foreach $dir (@directories)
	{
		&checkFiles($FORM{'base'}."$dir");
	}
}
else
{
	&checkFiles($FORM{'base'});
}

# Sortiermethode
if ($FORM{'sortmode'} eq '1')
{
	foreach $key ( sort ( keys( %DATA ) ) )
	{ 
		printDetails( $DATA{$key} );
	}
}
elsif ($FORM{'sortmode'} eq '2')
{
	foreach $key ( sort { $b cmp $a} ( keys( %DATA ) ) )
	{ 
		printDetails( $DATA{$key} );
	}
}
else
{ 
	foreach $key ( ( keys( %DATA ) ) )
	{ 
		printDetails( $DATA{$key} );
	}
}

# Ende der HTML-Ausgabe und Beenden des Scripts
&htmlBottom;
exit;

##############################
#Subroutinen
##############################

sub printDetails
{
	my($line) = shift;

	($fullFilename,$title,$date) = split( /\|/ , $line);
	
	print qq~
	<TR>
		<TD><A HREF="$fullFilename">$title</A></TD>
		<TD ALIGN="Right"><CODE>$date</CODE></TD>
	</TR>
	~;
}
	
sub checkFiles
{
	my($base) = shift;
	my($fullFilename);
	my(@lines);
	my($title);
	my($modtime);
	my($myexit);
	my($ok2dosub, $tmp, $excdir);
	
	opendir(ROOT,$base);
	@lines = readdir(ROOT);
	closedir(ROOT);

	foreach (@lines)
	{
		# Back-Directory-Eintraege werden nicht mit aufgefuehrt.
		next if /^\.|\.\.$/;

		$fullFilename = "$base/$_";

		if (-d $fullFilename)
		{
			if($subDir > 0)
			{
				$ok2dosub = 1;
				if($exclusion > 0)
				{
					$tmp = $fullFilename;
					$tmp =~ s/$FORM{'base'}//;
					foreach $excdir (@excdirs)
					{
						if($tmp =~ /$excdir/)
						{
							$ok2dosub = 0;
						}
					}
				}
				if($ok2dosub > 0)
				{
					checkFiles( $fullFilename);
				}
			}
			next;
		}

		# Es sollen nur HTML-Dateien beruecksichtigt werden.
		if (!($fullFilename =~ m/\.htm/i || $fullFilename =~ m/\.sht/i))
		{
			next;
		}

		# Die letzte Aenderung wird aus der PERL-Funktion stat gewonnen.
		$modTime = (stat($fullFilename))[9];

		$myexit = "0";

		# Es sollen nur Dateien im gewaehlten Zeitfenster beruecksichtigt werden.
		if ($modTime < $mytime)
		{
			next;
		}

		# Name, falls die Datei keinen Titel hat
		$title = "Ohne Titel";

		open(FILE,$fullFilename);
		while( $line =  <FILE> )
		{
			if ($line =~ m!<title>(.+)</title>!i)
			{
				$title = $1;
			}

			# Nosearch-Kommentare werden beruecksichtigt
			if ($line =~ m/<!-- nosearch -->/i)
			{
				$myexit = "1";
				last;
			}
		}
		close(FILE);

		if ($myexit eq "1")
		{
			next;
		}

		$fullFilename =~ s/$FORM{'base'}//g;
		$fullFilename = "$FORM{'rbase'}$fullFilename";

		$date  = localtime($modTime);
		$ndate = niceDate($date);
		$sdate = sortDate($date);
		
		$DATA{"$sdate$fullFilename"} = "$fullFilename|$title|$ndate";
	}
}

#-------------------------------------------
# Subroutine get_date
#-------------------------------------------

sub get_date
{
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = @_;

	if ($sec < 10)	{ $sec = "0$sec"; }
	if ($min < 10)	{ $min = "0$min"; }
	if ($hour < 10)	{ $hour = "0$hour"; }
	if ($mday < 10)	{ $mday = "0$mday"; }

	$month = ($mon + 1);
	if ($month < 10)	{ $month = "0$month"; }

	%weekds = (	"Mon","Montag",
			"Tue","Dienstag",
			"Wed","Mittwoch",
			"Thu","Donnerstag",
			"Fri","Freitag",
			"Sat","Samstag",
			"Sun","Sonntag");
	@months = ("Januar","Februar","Mrz ","April","Mai","Juni","Juli","August","September","Oktober","November","Dezember");

	$localtime = "$hour\:$min\:$sec";
	$date = "$mday\. $months[$mon] $year";
	chop($date) if ($date =~ /\n$/);
	chop($localtime) if ($localtime =~ /\n$/);

	$fulldate = $weekds{$wday} . ", " . $date . $localtime;
	return $fulldate;

} # Ende der Subroutine get_date


# Datum auf deutsch umsetzen
sub niceDate
{
	my($date) = shift;
	my($myDate);

	$myDate = substr($date,0,3). " ". substr($date, 8,2)."/".substr($date,4,3)."/".substr($date,20,4);
	$myDate = "$myDate ".substr($date,11,8);
    
	$myDate =~ s/Jan/01/gi;
	$myDate =~ s/Feb/02/gi;
	$myDate =~ s/Mar/03/gi;
	$myDate =~ s/Apr/04/gi;
	$myDate =~ s/May/05/gi;
	$myDate =~ s/Jun/06/gi;
	$myDate =~ s/Jul/07/gi;
	$myDate =~ s/Aug/08/gi;
	$myDate =~ s/Sep/09/gi;
	$myDate =~ s/Oct/10/gi;
	$myDate =~ s/Nov/11/gi;
	$myDate =~ s/Dec/12/gi;

	$myDate =~ s/Mon/Montag    /gi;
	$myDate =~ s/Tue/Dienstag  /gi;
	$myDate =~ s/Wed/Mittwoch  /gi;
	$myDate =~ s/Thu/Donnerstag/gi;
	$myDate =~ s/Fri/Freitag   /gi;
	$myDate =~ s/Sat/Samstag   /gi;
	$myDate =~ s/Sun/Sonntag   /gi;

	$myDate =~ s/ /&nbsp;/gi;
	$myDate =~ s/\//./gi;

	return $myDate;
}

# Formulardaten einlesen
sub parseForm
{
	my($key,$value);
	my($buffer);
	my(@lines);
	my($line);

	read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
	if ($buffer eq "") { $buffer = $ENV{'QUERY_STRING'}; }

	@lines = split( /&/, $buffer);
	foreach $line (@lines)
	{
		chomp($line);
		chomp($line);
		chomp($line);
		chomp($line);
		($key,$value) = split( /=/,$line);

		$key = lc($key);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C",hex($1))/eg;
		$value =~ s/\n//g;
		$value =~ s/\r/ /g;
		$value =~ s/</&lt;/g;
		$value =~ s/>/&gt;/g;
		$FORM{$key} = $value;
	}
	if ($FORM{'uname'} ne "")
	{
		$FORM{'base'} = "/usr/people/patrol/premium/$FORM{'uname'}/User_html";
		$FORM{'rbase'} = "/~$FORM{'uname'}";
	}
}

# Fehlermeldung
sub myError
{
	my($errmsg) = shift;

	print qq~
<HTML>
<HEAD>
<TITLE>changes.cgi - Fehler</TITLE>
</HEAD>
	~;

	&doBody;

	print qq~
<H2><font color=#003366">changes.cgi</font></H2>
Der folgende Fehler trat auf:<p>
<LI>$errmsg
</BODY>
</HTML>
	~;
	exit;
}

# Logbuch
sub writeLog
{
	my($site);

	$site = $ENV{'REMOTE_HOST'};
	if ($site eq "") { $site = $ENV{'REMOTE_ADDR'}; }

	if (!(-e "$FORM{'log'}" ))
	{
		open( OUTFILE,">$FORM{'log'}") or return;
		print OUTFILE "\"time\",\"remote site\"\n";
		close(OUTFILE);
	}

	open( OUTFILE,">>$FORM{'log'}") or return;
	print OUTFILE "\"" . localtime() . "\",\"$site\"\n";
	close( OUTFILE );
}

# Beginn der HTML-Ausgabe
sub htmlTop
{
	&get_date(localtime($mytime));

	print "Content-type: text/html\n\n";

	print qq~
<HTML>
<HEAD>
<TITLE>Was hat sich gendert in $FORM{'rbase'}</TITLE>
</HEAD>
	~;

	&doBody;

	print qq~
<font face="verdana, arial, helvetica">

<table border="0" cellpadding="4" cellspacing="0" width="100%">
	<tr>
		<td><h2><font color="#003366">nderungen in <BR>$FORM{'rbase'}</font></h2></td>
		<td><p align="right"><a target="_self" href="javascript:history.back()">Zurck</a></td>
	</tr>
</table>

Dateien, die seit dem $date modifiziert wurden:<p>
<TABLE WIDTH="100%">
	<TR>
		<TH ALIGN="Left">Dokument</TH>
		<TH ALIGN="right">Zuletzt modifiziert</TH>
	</TR>
	~;
}

# Ende der HTML-Ausgabe
sub htmlBottom
{
	$t2 = time();

	print qq~
</TABLE>
<HR>
<TABLE WIDTH="100%">
	<TR>
		<TD WIDTH="33%" ALIGN="Left">
		<FONT SIZE="1">Copyright &copy; 1997 <A HREF="http://www.ufbs.co.uk/jason/perl/jawhatschanged.html">Jason Anthony</A>
		<br>Deutsche bersetzung <a href="mailto:info\@gb-direkt.de">Gerold Bigorajski</a></FONT></TD>
		<TD ALIGN="center"><FONT SIZE="1">jawhatschanged.pl V$version</FONT></TD>
		<TD WIDTH="33%" ALIGN="Right"><FONT SIZE=2>Beanspruchte Zeit:
	~; 

	print $t2-$t1;
	print " Sekunde";
	if ($t2-$t1 == 1) { print "."; } else { print "n."; }
	
	print qq~
		</FONT></TD>
	</TR>
</TABLE>
</BODY>
</HTML>
	~;
}


# Body-Eigenschaften setzen
sub doBody
{
	my($line) = "<BODY";
	
	if ($FORM{'background'} ne "")
	{
		$line = "$line BACKGROUND=\"$FORM{'background'}\"";
	}
	if ($FORM{'bgcolor'} ne "")
	{
		$line = "$line BGCOLOR=\"$FORM{'bgcolor'}\"";
	}
	if ($FORM{'text'} ne "")
	{
		$line = "$line TEXT=\"$FORM{'text'}\"";
	}
	if ($FORM{'link'} ne "")
	{
		$line = "$line LINK=\"$FORM{'link'}\"";
	}
	if ($FORM{'alink'} ne "")
	{
		$line = "$line ALINK=\"$FORM{'alink'}\"";
	}
	if ($FORM{'vlink'} ne "")
	{
		$line = "$line VLINK=\"$FORM{'vlink'}\"";
	}
	$line = "$line>\n";
	print $line;
}

# Datumssortierung
sub sortDate
{ 
	my($date) = shift;
	my($myDate);
	
	$myDate = substr($date,20,4);
	
	if (lc(substr($date,4,3)) eq "jan") { $myDate = $myDate . "01"; }
	if (lc(substr($date,4,3)) eq "feb") { $myDate = $myDate . "02"; }
	if (lc(substr($date,4,3)) eq "mar") { $myDate = $myDate . "03"; }
	if (lc(substr($date,4,3)) eq "apr") { $myDate = $myDate . "04"; }
	if (lc(substr($date,4,3)) eq "may") { $myDate = $myDate . "05"; }
	if (lc(substr($date,4,3)) eq "jun") { $myDate = $myDate . "06"; }
	if (lc(substr($date,4,3)) eq "jul") { $myDate = $myDate . "07"; }
	if (lc(substr($date,4,3)) eq "aug") { $myDate = $myDate . "08"; }
	if (lc(substr($date,4,3)) eq "sep") { $myDate = $myDate . "09"; }
	if (lc(substr($date,4,3)) eq "oct") { $myDate = $myDate . "10"; }
	if (lc(substr($date,4,3)) eq "nov") { $myDate = $myDate . "11"; }
	if (lc(substr($date,4,3)) eq "dec") { $myDate = $myDate . "12"; }
	
	$myDate = $myDate . substr($date,8,2) . substr($date,11,8);
	$myDate =~ tr/ /0/;
	return $myDate;
}
